Index: contrib/ntp/ntpd/ntp_parser.c
===================================================================
--- contrib/ntp/ntpd/ntp_parser.c	(版本 314126)
+++ contrib/ntp/ntpd/ntp_parser.c	(版本 316722)
@@ -3210,7 +3210,7 @@
     break;
 
   case 288:
-#line 1472 "../../ntpd/ntp_parser.y" /* yacc.c:1646  */
+#line 1472 "ntp_parser.y" /* yacc.c:1646  */
     {
 			(yyval.String_fifo) = NULL;
 			APPEND_G_FIFO((yyval.String_fifo), create_string_node((yyvsp[0].String)));
@@ -3219,7 +3219,7 @@
     break;
 
   case 289:
-#line 1480 "../../ntpd/ntp_parser.y" /* yacc.c:1646  */
+#line 1480 "ntp_parser.y" /* yacc.c:1646  */
     {
 			(yyval.Address_fifo) = (yyvsp[-1].Address_fifo);
 			APPEND_G_FIFO((yyval.Address_fifo), (yyvsp[0].Address_node));
@@ -3228,7 +3228,7 @@
     break;
 
   case 290:
-#line 1485 "../../ntpd/ntp_parser.y" /* yacc.c:1646  */
+#line 1485 "ntp_parser.y" /* yacc.c:1646  */
     {
 			(yyval.Address_fifo) = NULL;
 			APPEND_G_FIFO((yyval.Address_fifo), (yyvsp[0].Address_node));
@@ -3237,7 +3237,7 @@
     break;
 
   case 291:
-#line 1493 "../../ntpd/ntp_parser.y" /* yacc.c:1646  */
+#line 1493 "ntp_parser.y" /* yacc.c:1646  */
     {
 			if ((yyvsp[0].Integer) != 0 && (yyvsp[0].Integer) != 1) {
 				yyerror("Integer value is not boolean (0 or 1). Assuming 1");
@@ -3250,25 +3250,25 @@
     break;
 
   case 292:
-#line 1501 "../../ntpd/ntp_parser.y" /* yacc.c:1646  */
+#line 1501 "ntp_parser.y" /* yacc.c:1646  */
     { (yyval.Integer) = 1; }
 #line 3256 "ntp_parser.c" /* yacc.c:1646  */
     break;
 
   case 293:
-#line 1502 "../../ntpd/ntp_parser.y" /* yacc.c:1646  */
+#line 1502 "ntp_parser.y" /* yacc.c:1646  */
     { (yyval.Integer) = 0; }
 #line 3262 "ntp_parser.c" /* yacc.c:1646  */
     break;
 
   case 294:
-#line 1506 "../../ntpd/ntp_parser.y" /* yacc.c:1646  */
+#line 1506 "ntp_parser.y" /* yacc.c:1646  */
     { (yyval.Double) = (double)(yyvsp[0].Integer); }
 #line 3268 "ntp_parser.c" /* yacc.c:1646  */
     break;
 
   case 296:
-#line 1517 "../../ntpd/ntp_parser.y" /* yacc.c:1646  */
+#line 1517 "ntp_parser.y" /* yacc.c:1646  */
     {
 			sim_node *sn;
 
@@ -3282,13 +3282,13 @@
     break;
 
   case 297:
-#line 1534 "../../ntpd/ntp_parser.y" /* yacc.c:1646  */
+#line 1534 "ntp_parser.y" /* yacc.c:1646  */
     { old_config_style = 0; }
 #line 3288 "ntp_parser.c" /* yacc.c:1646  */
     break;
 
   case 298:
-#line 1539 "../../ntpd/ntp_parser.y" /* yacc.c:1646  */
+#line 1539 "ntp_parser.y" /* yacc.c:1646  */
     {
 			(yyval.Attr_val_fifo) = (yyvsp[-2].Attr_val_fifo);
 			APPEND_G_FIFO((yyval.Attr_val_fifo), (yyvsp[-1].Attr_val));
@@ -3297,7 +3297,7 @@
     break;
 
   case 299:
-#line 1544 "../../ntpd/ntp_parser.y" /* yacc.c:1646  */
+#line 1544 "ntp_parser.y" /* yacc.c:1646  */
     {
 			(yyval.Attr_val_fifo) = NULL;
 			APPEND_G_FIFO((yyval.Attr_val_fifo), (yyvsp[-1].Attr_val));
@@ -3306,13 +3306,13 @@
     break;
 
   case 300:
-#line 1552 "../../ntpd/ntp_parser.y" /* yacc.c:1646  */
+#line 1552 "ntp_parser.y" /* yacc.c:1646  */
     { (yyval.Attr_val) = create_attr_dval((yyvsp[-2].Integer), (yyvsp[0].Double)); }
 #line 3312 "ntp_parser.c" /* yacc.c:1646  */
     break;
 
   case 303:
-#line 1562 "../../ntpd/ntp_parser.y" /* yacc.c:1646  */
+#line 1562 "ntp_parser.y" /* yacc.c:1646  */
     {
 			(yyval.Sim_server_fifo) = (yyvsp[-1].Sim_server_fifo);
 			APPEND_G_FIFO((yyval.Sim_server_fifo), (yyvsp[0].Sim_server));
@@ -3321,7 +3321,7 @@
     break;
 
   case 304:
-#line 1567 "../../ntpd/ntp_parser.y" /* yacc.c:1646  */
+#line 1567 "ntp_parser.y" /* yacc.c:1646  */
     {
 			(yyval.Sim_server_fifo) = NULL;
 			APPEND_G_FIFO((yyval.Sim_server_fifo), (yyvsp[0].Sim_server));
@@ -3330,25 +3330,25 @@
     break;
 
   case 305:
-#line 1575 "../../ntpd/ntp_parser.y" /* yacc.c:1646  */
+#line 1575 "ntp_parser.y" /* yacc.c:1646  */
     { (yyval.Sim_server) = ONLY_SIM(create_sim_server((yyvsp[-4].Address_node), (yyvsp[-2].Double), (yyvsp[-1].Sim_script_fifo))); }
 #line 3336 "ntp_parser.c" /* yacc.c:1646  */
     break;
 
   case 306:
-#line 1580 "../../ntpd/ntp_parser.y" /* yacc.c:1646  */
+#line 1580 "ntp_parser.y" /* yacc.c:1646  */
     { (yyval.Double) = (yyvsp[-1].Double); }
 #line 3342 "ntp_parser.c" /* yacc.c:1646  */
     break;
 
   case 307:
-#line 1585 "../../ntpd/ntp_parser.y" /* yacc.c:1646  */
+#line 1585 "ntp_parser.y" /* yacc.c:1646  */
     { (yyval.Address_node) = (yyvsp[0].Address_node); }
 #line 3348 "ntp_parser.c" /* yacc.c:1646  */
     break;
 
   case 308:
-#line 1590 "../../ntpd/ntp_parser.y" /* yacc.c:1646  */
+#line 1590 "ntp_parser.y" /* yacc.c:1646  */
     {
 			(yyval.Sim_script_fifo) = (yyvsp[-1].Sim_script_fifo);
 			APPEND_G_FIFO((yyval.Sim_script_fifo), (yyvsp[0].Sim_script));
@@ -3357,7 +3357,7 @@
     break;
 
   case 309:
-#line 1595 "../../ntpd/ntp_parser.y" /* yacc.c:1646  */
+#line 1595 "ntp_parser.y" /* yacc.c:1646  */
     {
 			(yyval.Sim_script_fifo) = NULL;
 			APPEND_G_FIFO((yyval.Sim_script_fifo), (yyvsp[0].Sim_script));
@@ -3366,13 +3366,13 @@
     break;
 
   case 310:
-#line 1603 "../../ntpd/ntp_parser.y" /* yacc.c:1646  */
+#line 1603 "ntp_parser.y" /* yacc.c:1646  */
     { (yyval.Sim_script) = ONLY_SIM(create_sim_script_info((yyvsp[-3].Double), (yyvsp[-1].Attr_val_fifo))); }
 #line 3372 "ntp_parser.c" /* yacc.c:1646  */
     break;
 
   case 311:
-#line 1608 "../../ntpd/ntp_parser.y" /* yacc.c:1646  */
+#line 1608 "ntp_parser.y" /* yacc.c:1646  */
     {
 			(yyval.Attr_val_fifo) = (yyvsp[-2].Attr_val_fifo);
 			APPEND_G_FIFO((yyval.Attr_val_fifo), (yyvsp[-1].Attr_val));
@@ -3381,7 +3381,7 @@
     break;
 
   case 312:
-#line 1613 "../../ntpd/ntp_parser.y" /* yacc.c:1646  */
+#line 1613 "ntp_parser.y" /* yacc.c:1646  */
     {
 			(yyval.Attr_val_fifo) = NULL;
 			APPEND_G_FIFO((yyval.Attr_val_fifo), (yyvsp[-1].Attr_val));
@@ -3390,7 +3390,7 @@
     break;
 
   case 313:
-#line 1621 "../../ntpd/ntp_parser.y" /* yacc.c:1646  */
+#line 1621 "ntp_parser.y" /* yacc.c:1646  */
     { (yyval.Attr_val) = create_attr_dval((yyvsp[-2].Integer), (yyvsp[0].Double)); }
 #line 3396 "ntp_parser.c" /* yacc.c:1646  */
     break;
@@ -3624,7 +3624,7 @@
 #endif
   return yyresult;
 }
-#line 1632 "../../ntpd/ntp_parser.y" /* yacc.c:1906  */
+#line 1632 "ntp_parser.y" /* yacc.c:1906  */
 
 
 void
Index: contrib/ntp/ntpd/ntp_restrict.c
===================================================================
--- contrib/ntp/ntpd/ntp_restrict.c	(版本 314126)
+++ contrib/ntp/ntpd/ntp_restrict.c	(版本 316722)
@@ -166,7 +166,7 @@
 	if (res != NULL)
 		return res;
 
-	rl = emalloc_zero(count * cb);
+	rl = eallocarray(count, cb);
 	/* link all but the first onto free list */
 	res = (void *)((char *)rl + (count - 1) * cb);
 	for (i = count - 1; i > 0; i--) {
@@ -192,7 +192,7 @@
 	if (res != NULL)
 		return res;
 
-	rl = emalloc_zero(count * cb);
+	rl = eallocarray(count, cb);
 	/* link all but the first onto free list */
 	res = (void *)((char *)rl + (count - 1) * cb);
 	for (i = count - 1; i > 0; i--) {
Index: contrib/ntp/ntpd/ntpd.1ntpdman
===================================================================
--- contrib/ntp/ntpd/ntpd.1ntpdman	(版本 314126)
+++ contrib/ntp/ntpd/ntpd.1ntpdman	(版本 316722)
@@ -10,11 +10,11 @@
 .ds B-Font B
 .ds I-Font I
 .ds R-Font R
-.TH ntpd 1ntpdman "21 Nov 2016" "4.2.8p9" "User Commands"
+.TH ntpd 1ntpdman "21 Mar 2017" "4.2.8p10" "User Commands"
 .\"
-.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-giaGkh/ag-tiayjh)
+.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-wcairs/ag-fdaWls)
 .\"
-.\" It has been AutoGen-ed November 21, 2016 at 08:01:50 AM by AutoGen 5.18.5
+.\" It has been AutoGen-ed March 21, 2017 at 10:44:13 AM by AutoGen 5.18.5
 .\" From the definitions ntpd-opts.def
 .\" and the template file agman-cmd.tpl
 .SH NAME
@@ -979,7 +979,7 @@
 .SH "AUTHORS"
 The University of Delaware and Network Time Foundation
 .SH "COPYRIGHT"
-Copyright (C) 1992-2016 The University of Delaware and Network Time Foundation all rights reserved.
+Copyright (C) 1992-2017 The University of Delaware and Network Time Foundation all rights reserved.
 This program is released under the terms of the NTP license, <http://ntp.org/license>.
 .SH BUGS
 The
Index: contrib/ntp/ntpd/ntpd.man.in
===================================================================
--- contrib/ntp/ntpd/ntpd.man.in	(版本 314126)
+++ contrib/ntp/ntpd/ntpd.man.in	(版本 316722)
@@ -10,11 +10,11 @@
 .ds B-Font B
 .ds I-Font I
 .ds R-Font R
-.TH ntpd @NTPD_MS@ "21 Nov 2016" "4.2.8p9" "User Commands"
+.TH ntpd @NTPD_MS@ "21 Mar 2017" "4.2.8p10" "User Commands"
 .\"
-.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-giaGkh/ag-tiayjh)
+.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-wcairs/ag-fdaWls)
 .\"
-.\" It has been AutoGen-ed November 21, 2016 at 08:01:50 AM by AutoGen 5.18.5
+.\" It has been AutoGen-ed March 21, 2017 at 10:44:13 AM by AutoGen 5.18.5
 .\" From the definitions ntpd-opts.def
 .\" and the template file agman-cmd.tpl
 .SH NAME
@@ -979,7 +979,7 @@
 .SH "AUTHORS"
 The University of Delaware and Network Time Foundation
 .SH "COPYRIGHT"
-Copyright (C) 1992-2016 The University of Delaware and Network Time Foundation all rights reserved.
+Copyright (C) 1992-2017 The University of Delaware and Network Time Foundation all rights reserved.
 This program is released under the terms of the NTP license, <http://ntp.org/license>.
 .SH BUGS
 The
Index: contrib/ntp/ntpd/refclock_jjy.c
===================================================================
--- contrib/ntp/ntpd/refclock_jjy.c	(版本 314126)
+++ contrib/ntp/ntpd/refclock_jjy.c	(版本 316722)
@@ -592,7 +592,7 @@
 	l_fp	tRecvTimestamp;		/* arrival timestamp */
 	int 	rc ;
 	char	*pBuf, sLogText [ MAX_LOGTEXT ] ;
-	int 	iLen, iCopyLen ;
+	size_t 	iLen, iCopyLen ;
 	int 	i, j, iReadRawBuf, iBreakPosition ;
 
 	/*
@@ -744,8 +744,8 @@
 		}
 
 		iCopyLen = ( iLen <= sizeof(sLogText)-1 ? iLen : sizeof(sLogText)-1 ) ;
-		strncpy( sLogText, pBuf, iCopyLen ) ;
-		sLogText[iCopyLen] = 0 ;
+		memcpy( sLogText, pBuf, iCopyLen ) ;
+		sLogText[iCopyLen] = '\0' ;
 		jjy_write_clockstats( peer, JJY_CLOCKSTATS_MARK_RECEIVE, sLogText ) ;
 
 		switch ( up->unittype ) {
@@ -2688,8 +2688,9 @@
 {
 
 	char	sLog [ 80 ], sFirstThreeDigits [ 4 ] ;
-	int	i, iNumberOfDigitsOfPhoneNumber, iCommaCount, iCommaPosition ;
-	int	iFirstThreeDigitsCount ;
+	int	iNumberOfDigitsOfPhoneNumber, iCommaCount, iCommaPosition ;
+	size_t  i ;
+	size_t	iFirstThreeDigitsCount ;
 
 	jjy_write_clockstats( peer, JJY_CLOCKSTATS_MARK_JJY, "Refclock: Telephone JJY" ) ;
 
@@ -3823,7 +3824,7 @@
 	struct	jjyunit		*up;
 	struct	refclockproc	*pp;
 	char	*pBuf ;
-	int	iLen ;
+	size_t	iLen ;
 
 #ifdef DEBUG
 	static const char *sFunctionName = "modem_receive" ;
@@ -3857,11 +3858,11 @@
 #ifdef DEBUG
 	if ( debug ) {
 		char	sResp [ 40 ] ;
-		int	iCopyLen ;
+		size_t	iCopyLen ;
 		iCopyLen = ( iLen <= sizeof(sResp)-1 ? iLen : sizeof(sResp)-1 ) ;
 		strncpy( sResp, pBuf, iLen <= sizeof(sResp)-1 ? iLen : sizeof(sResp)-1 ) ;
 		sResp[iCopyLen] = 0 ;
-		printf ( "refclock_jjy.c : modem_receive : iLen=%d pBuf=[%s] iModemEvent=%d\n", iCopyLen, sResp, up->iModemEvent ) ;
+		printf ( "refclock_jjy.c : modem_receive : iLen=%zu pBuf=[%s] iModemEvent=%d\n", iCopyLen, sResp, up->iModemEvent ) ;
 	}
 #endif
 	modem_control ( peer, pp, up ) ;
Index: contrib/ntp/ntpd/refclock_parse.c
===================================================================
--- contrib/ntp/ntpd/refclock_parse.c	(版本 314126)
+++ contrib/ntp/ntpd/refclock_parse.c	(版本 316722)
@@ -3675,8 +3675,7 @@
 			}
 		}
 
-		tt = ap(start, LEN_STATES, tt,
-		    "; running time: %s\"", l_mktime(sum));
+		ap(start, LEN_STATES, tt, "; running time: %s\"", l_mktime(sum));
 
 		tt = add_var(&out->kv_list, 32, RO);
 		snprintf(tt, 32,  "refclock_id=\"%s\"", parse->parse_type->cl_id);
@@ -4226,13 +4225,13 @@
 
 static void
 mk_utcinfo(
-	   char *t,  // pointer to the output string buffer
-	   int wnt,
-	   int wnlsf,
+	   char *t,  /* pointer to the output string buffer */
+	   uint16_t wnt,
+	   uint16_t wnlsf,
 	   int dn,
 	   int dtls,
 	   int dtlsf,
-	   int size  // size of the output string buffer
+	   int size  /* size of the output string buffer */
 	   )
 {
 	/*
@@ -4248,32 +4247,37 @@
 	{
 		time_t t_ls;
 		struct tm *tm;
-		int n = 0;
+		int nc;
 
 		if (wnlsf < GPSWRAP)
 			wnlsf += GPSWEEKS;
+		/* 'wnt' not used here: would need the same treatment as 'wnlsf */
 
-		if (wnt < GPSWRAP)
-			wnt += GPSWEEKS;
-
 		t_ls = (time_t) wnlsf * SECSPERWEEK
 			+ (time_t) dn * SECSPERDAY
 			+ GPS_SEC_BIAS - 1;
 
 		tm = gmtime( &t_ls );
-		if (tm == NULL)  // gmtime() failed
+		if (tm == NULL)  /* gmtime() failed */
 		{
 			snprintf( t, size, "** (gmtime() failed in mk_utcinfo())" );
 			return;
 		}
 
-		n += snprintf( t, size, "UTC offset transition from %is to %is due to leap second %s",
+		nc = snprintf( t, size, "UTC offset transition from %is to %is due to leap second %s",
 				dtls, dtlsf, ( dtls < dtlsf ) ? "insertion" : "deletion" );
-		n += snprintf( t + n, size - n, " at UTC midnight at the end of %s, %04i-%02i-%02i",
+		if (nc < 0)
+			nc = strlen(t);
+		else if (nc > size)
+			nc = size;
+		
+		snprintf( t + nc, size - nc, " at UTC midnight at the end of %s, %04i-%02i-%02i",
 				daynames[tm->tm_wday], tm->tm_year + 1900, tm->tm_mon + 1, tm->tm_mday );
 	}
 	else
+	{
 		snprintf( t, size, "UTC offset parameter: %is, no leap second announced.\n", dtls );
+	}
 
 }
 
Index: contrib/ntp/ntpdc/Makefile.am
===================================================================
--- contrib/ntp/ntpdc/Makefile.am	(版本 314126)
+++ contrib/ntp/ntpdc/Makefile.am	(版本 316722)
@@ -9,12 +9,15 @@
 BUILT_SOURCES=	@MAKE_CHECK_LAYOUT@ ntpdc-opts.c ntpdc-opts.h
 
 AM_CFLAGS = $(CFLAGS_NTP)
+AM_CFLAGS += $(NTP_HARD_CFLAGS)
 
 AM_CPPFLAGS  = $(NTP_INCS)
 AM_CPPFLAGS += $(LIBOPTS_CFLAGS)
 AM_CPPFLAGS += $(CPPFLAGS_NTP)
+AM_CPPFLAGS += $(NTP_HARD_CPPFLAGS)
 
 AM_LDFLAGS = $(LDFLAGS_NTP)
+AM_LDFLAGS += $(NTP_HARD_LDFLAGS)
 
 # LDADD might need RESLIB and ADJLIB
 ntpdc_LDADD  = version.o $(LIBOPTS_LDADD)
Index: contrib/ntp/ntpdc/ntpdc-opts.h
===================================================================
--- contrib/ntp/ntpdc/ntpdc-opts.h	(版本 314126)
+++ contrib/ntp/ntpdc/ntpdc-opts.h	(版本 316722)
@@ -1,7 +1,7 @@
 /*
  *  EDIT THIS FILE WITH CAUTION  (ntpdc-opts.h)
  *
- *  It has been AutoGen-ed  November 21, 2016 at 08:02:17 AM by AutoGen 5.18.5
+ *  It has been AutoGen-ed  March 21, 2017 at 10:44:43 AM by AutoGen 5.18.5
  *  From the definitions    ntpdc-opts.def
  *  and the template file   options
  *
@@ -18,7 +18,7 @@
  * The ntpdc program is copyrighted and licensed
  * under the following terms:
  *
- *  Copyright (C) 1992-2016 The University of Delaware and Network Time Foundation, all rights reserved.
+ *  Copyright (C) 1992-2017 The University of Delaware and Network Time Foundation, all rights reserved.
  *  This is free software. It is licensed for use, modification and
  *  redistribution under the terms of the NTP License, copies of which
  *  can be seen at:
@@ -83,9 +83,9 @@
 /** count of all options for ntpdc */
 #define OPTION_CT    15
 /** ntpdc version */
-#define NTPDC_VERSION       "4.2.8p9"
+#define NTPDC_VERSION       "4.2.8p10"
 /** Full ntpdc version text */
-#define NTPDC_FULL_VERSION  "ntpdc 4.2.8p9"
+#define NTPDC_FULL_VERSION  "ntpdc 4.2.8p10"
 
 /**
  *  Interface defines for all options.  Replace "n" with the UPPER_CASED
Index: contrib/ntp/ntpd/refclock_gpsdjson.c
===================================================================
--- contrib/ntp/ntpd/refclock_gpsdjson.c	(版本 314126)
+++ contrib/ntp/ntpd/refclock_gpsdjson.c	(版本 316722)
@@ -2112,13 +2112,15 @@
 	clockprocT * const pp,
 	const char * const tc)
 {
-	size_t len;
-
-	len = (tc) ? strlen(tc) : 0;
-	if (len >= sizeof(pp->a_lastcode))
-		len = sizeof(pp->a_lastcode) - 1;
+	size_t len = 0;
+	
+	if (tc) {
+		len = strlen(tc);
+		if (len >= sizeof(pp->a_lastcode))
+			len = sizeof(pp->a_lastcode) - 1;
+		memcpy(pp->a_lastcode, tc, len);
+	}
 	pp->lencode = (u_short)len;
-	memcpy(pp->a_lastcode, tc, len);
 	pp->a_lastcode[len] = '\0';
 }
 
Index: contrib/ntp/ntpd/refclock_oncore.c
===================================================================
--- contrib/ntp/ntpd/refclock_oncore.c	(版本 314126)
+++ contrib/ntp/ntpd/refclock_oncore.c	(版本 316722)
@@ -1461,7 +1461,7 @@
 #endif
 
 	i = rbufp->recv_length;
-	if (rcvbuf+rcvptr+i > &rcvbuf[sizeof rcvbuf])
+	if ((size_t)rcvptr + i >= sizeof(rcvbuf))
 		i = sizeof(rcvbuf) - rcvptr;	/* and some char will be lost */
 	memcpy(rcvbuf+rcvptr, p, i);
 	rcvptr += i;
@@ -2514,8 +2514,6 @@
 		WARN_MINUS
 	} warn;
 
-	day_now = day_lsf = 0;
-	cp = NULL;	/* keep gcc happy */
 
 	subframe = buf[6] & 017;
 	valid = (buf[6] >> 4) & 017;
@@ -2590,6 +2588,9 @@
 			instance->peer->leap = LEAP_ADDSECOND;
 			cp = "Set peer.leap to LEAP_ADDSECOND";
 			break;
+		default:
+			cp = NULL;
+			break;
 		}
 		oncore_log(instance, LOG_NOTICE, cp);
 
@@ -3379,7 +3380,6 @@
 {
 	enum antenna_state antenna;		/* antenna state */
 
-	antenna = instance->ant_state;
 	if (instance->chan == 12)
 		antenna = (instance->BEHa[130] & 0x6 ) >> 1;
 	else
Index: contrib/ntp/ntpdate/ntpdate.c
===================================================================
--- contrib/ntp/ntpdate/ntpdate.c	(版本 314126)
+++ contrib/ntp/ntpdate/ntpdate.c	(版本 316722)
@@ -955,6 +955,8 @@
 	register int i, j;
 	int ord[NTP_SHIFT];
 
+	INSIST((0 < sys_samples) && (sys_samples <= NTP_SHIFT));
+	
 	/*
 	 * Sort indices into increasing delay order
 	 */
